// admin 需要最后运行，并在route中进行过滤。
import { Route } from '@kevisual/router';
import { app } from './app.ts';
import { manager, updateNewCode, removeCode, stopCode, startCode } from './dashboard/manager.ts';
// get manager status
export const managerRouter = new Route('admin', 'getManagerStatus');
managerRouter.run = async (ctx) => {
  ctx.body = {
    status: manager.loaded,
    msg: 'system is running, and load manager success.',
  };
  return ctx;
};
managerRouter.addTo(app);

// get manager list
app
  .route({
    path: 'admin',
    key: 'getManagerList',
  })
  .define(async (ctx) => {
    ctx.body = manager.list;
    // TODO: routerList 可以不暴露
    const routerList = ctx.queryRouter.getList().filter((r) => !r.path.startsWith('admin'));
    ctx.body = {
      list: manager.list,
      routerList,
    };
    return ctx;
  })
  .addTo(app);

// get manager one
export const managerOne = new Route('admin', 'getManagerOne');
managerOne.run = async (ctx) => {
  const verfiy = ctx.currentRoute.verify(ctx);
  if (verfiy) return;

  const { id } = ctx.query;
  const code = manager.list.find((c) => c.id === id);
  if (code) {
    ctx.body = code;
  } else {
    ctx.body = 'not found';
    ctx.code = 404;
  }

  return ctx;
};
managerOne.validator = {
  id: {
    type: 'string',
    required: true,
  },
};

managerOne.addTo(app);
