import Neode from 'neode';
import { useConfig } from '@kevisual/use-config';
import neo4j from 'neo4j-driver';

type NeodeConfig = {
  uri: string;
  username: string;
  password: string;
};
const { neo4j: neo4jConfig } = useConfig<{ neo4j: NeodeConfig }>('neo4j');

const { uri, username, password } = neo4jConfig;
// 设置连接配置
// const neode = new Neode('bolt://localhost:7687', 'neo4j', 'your_password');
export const neode = new Neode(uri, username, password);
// 创建与 Neo4j 数据库的连接
export const neoDriver = neo4j.driver(
  uri, // 数据库地址
  neo4j.auth.basic(username, password), // 用户名和密码
);
export const getSession = () => {
  return neoDriver.session();
};

const testConnect = async () => {
  // 连接成功
  // 尝试执行简单的 Cypher 查询以测试连接
  neode
    .cypher('RETURN 1', {})
    .then(() => {
      console.log('connect neo4j success');
    })
    .catch((err) => {
      console.error('Failed to connect:', err);
    });
};

testConnect();
