import { app } from '@/app.ts';
import { manager } from '../manager-app.ts';

app
  .route({
    path: 'micro-app-manager',
    key: 'list',
  })
  .define(async (ctx) => {
    const list = manager.getAllAppShowInfo();
    ctx.body = list;
  })
  .addTo(app);

app
  .route({
    path: 'micro-app-manager',
    key: 'updateStatus',
  })
  .define(async (ctx) => {
    const { status, key } = ctx.query;
    if (!status || !key) {
      ctx.body = 'status or key is required';
      return;
    }
    if (status === 'start') {
      await manager.start(key);
    } else if (status === 'stop') {
      await manager.stop(key);
    }
    const appShow = manager.getAppShowInfo(key);
    ctx.body = appShow;
  })
  .addTo(app);

app
  .route({
    path: 'micro-app-manager',
    key: 'update',
  })
  .define(async (ctx) => {
    const { key } = ctx.query.data || {};
    if (!key) {
      ctx.body = 'key is required';
      return;
    }
    const appInfo = await manager.updateAppInfo(key, ctx.query.data);
    ctx.body = appInfo;
  })
  .addTo(app);

setTimeout(() => {
  manager.load().then(() => {
    console.log('load success');
  });
}, 1000);
